indexing
	description: "Objects that test features of BASIC_ROUTINES class"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	BASIC_ROUTINES_TESTER

inherit
	CLASS_TESTER

	BASIC_ROUTINES

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (25)
			test2 (10)
			test3 (10)
			test4 (15)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (250)
			test2 (100)
			test3 (100)
			test4 (150)
		end

feature {NONE} -- Parameters
	bound: INTEGER is 100
			-- Bound for normal integer values

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (random values from [-bound, bound])
		local
			i, n, m, res: INTEGER
			rres: REAL
			cres: CHARACTER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-bound, bound)
				random.forth
				from
					m := random.bounded_item (-bound, bound)
					random.forth
				until
					m /= 0
				loop
					-- m is the divisor
					m := random.bounded_item (-bound, bound)
					random.forth
				end
				cres := charconv (n)
				res := abs (n)
				res := sign (n)
				rres := rsign (n)
				res := bottom_int_div (n, m)
				res := up_int_div (n, m)
				i := i + 1
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (special values {-1, 0, 1})
		local
			i, n, m, res: INTEGER
			rres: REAL
			cres: CHARACTER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-1, 1)
				random.forth
				if random.decide (0.5) then
					m := 1
				else
					m := -1
				end
				random.forth
				cres := charconv (n)
				res := abs (n)
				res := sign (n)
				rres := rsign (n)
				res := bottom_int_div (n, m)
				res := up_int_div (n, m)
				i := i + 1
			end
		end

	test3 (count: INTEGER) is
			-- Test 3 (big values)
		local
			i, n, m, res: INTEGER
			rres: REAL
			cres: CHARACTER
		do
			from
				i := 1
			until
				i > count
			loop
				if random.decide (0.5) then
					random.forth
					n := random.bounded_item ({INTEGER}.min_value, {INTEGER}.min_value // 2)
					random.forth
				else
					random.forth
					n := random.bounded_item ({INTEGER}.max_value // 2, {INTEGER}.max_value)
					random.forth
				end

				if random.decide (0.5) then
					random.forth
					m := random.bounded_item ({INTEGER}.min_value, {INTEGER}.min_value // 2)
					random.forth
				else
					random.forth
					m := random.bounded_item ({INTEGER}.max_value // 2, {INTEGER}.max_value)
					random.forth
				end

				cres := charconv (n)
				res := abs (n)
				res := sign (n)
				rres := rsign (n)
				res := bottom_int_div (n, m)
				res := up_int_div (n, m)
				i := i + 1
			end
		end

	test4 (count: INTEGER) is
			-- Test 4 (n = m)
		local
			i, n, res: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				n := random.bounded_item (-bound, bound)
				random.forth
				if n /= 0 then
					res := bottom_int_div (n, n)
					res := up_int_div (n, n)
				end
				i := i + 1
			end
		end
end
