indexing
	description: "Objects that execute features of BOOLEAN_REF"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	BOOLEAN_REF_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (50)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (500)
		end

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (random boolean values)
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				x := random.decide (0.5).to_reference
				random.forth
				y := random.decide (0.5).to_reference
				random.forth
				execute_unary_functions
				execute_binary_functions
				i := i + 1
			end
		end

feature {NONE} -- Implementation
	execute_unary_functions is
			-- Execute all unary functions with `x'
		local
			n: INTEGER
			s: STRING
		do
			n := x.hash_code
			z := x.is_hashable
			n := x.to_integer
			z := not x
			s := x.out
		end

	execute_binary_functions is
			-- Execute all binary functions with `x' and `y'
		do
			z := x and y
			z := x and then y
			z := x implies y
			z := x or y
			z := x or else y
			z := x xor y
		end

	x, y, z: BOOLEAN_REF
end
