indexing
	description: "Objects that execute features of class EDGE"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class EDGE_TESTER

inherit
	CLASS_TESTER
		undefine
			out
		end

	LINKED_GRAPH [STRING, STRING]
		rename
			item as graph_item,
			make_empty_linked_graph as make
		end

create
	make

feature -- Basic operations

	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test2 (50)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test2 (500)
		end

feature {NONE} -- Tests

	size_bound: INTEGER is 255

	test1 (n: INTEGER) is
			-- Random tests
		require
			n_positive: n >= 1
		local
			e_d, e_u, e_d2, e_u2: EDGE [STRING, STRING]
			n1, n2, n3, n4, n5, n6, n7, n8, s: STRING
			i, j: INTEGER
			b: BOOLEAN
		do
			from
				i := 1
			until
				i > n
			loop
				n1 := random.alpha_string_item (size_bound)
				n2 := random.alpha_string_item (size_bound)
				create e_d.make_directed (n1, n2, random.alpha_string_or_void_item (size_bound))
				n3 := random.alpha_string_item (size_bound)
				n4 := random.alpha_string_item (size_bound)
				create e_u.make_undirected (n3, n4, random.alpha_string_or_void_item (size_bound))

				random.forth
				j := random.item \\ 2
				if j = 0 then
					s := e_u.opposite_node (n3)
				else
					s := e_u.opposite_node (n4)
				end

				random.forth
				j := random.item \\ 2
				if j = 0 then
					b := e_u.is_loop
				else
					b := e_d.is_loop
				end

				n5 := random.alpha_string_item (size_bound)
				n6 := random.alpha_string_item (size_bound)
				create e_d2.make_directed (n5, n6, random.alpha_string_or_void_item (size_bound))
				n7 := random.alpha_string_item (size_bound)
				n8 := random.alpha_string_item (size_bound)
				create e_u2.make_undirected (n7, n8, random.alpha_string_or_void_item (size_bound))
				random.forth
				j := random.item \\ 4
				if j = 0 then
					b := e_u.is_equal (e_u2)
				elseif j = 1 then
					b := e_u.is_equal (e_d2)
				elseif j = 2 then
					b := e_d.is_equal (e_u2)
				else
					b := e_d.is_equal (e_d2)
				end

				random.forth
				j := random.item \\ 2
				s := random.alpha_string_or_void_item (size_bound)
				if j = 0 then
					e_u.set_label (s)
				else
					e_d.set_label (s)
				end

				random.forth
				j := random.item \\ 2
				if j = 0 then
					s := e_u.out
				else
					s := e_d.out
				end

				i := i + 1
			end

		end

	test2 (n: INTEGER) is
			-- Partition testing + random testing.
		require
			n_positive: n >= 1
		local
			e_d, e_u, e_d_l, e_u_l, e_d2, e_u2: EDGE [STRING, STRING]
			n1, n2, n3, n4, s, l: STRING
			i: INTEGER
			b: BOOLEAN
		do
			from
				i := 1
			until
				i > n
			loop
				n1 := random.alpha_string_item (size_bound)
				n2 := random.alpha_string_item (size_bound)
				create e_d.make_directed (n1, n2, random.alpha_string_or_void_item (size_bound))
				create e_d_l.make_directed (n1, n1, random.alpha_string_or_void_item (size_bound))
				n3 := random.alpha_string_item (size_bound)
				n4 := random.alpha_string_item (size_bound)
				l := random.alpha_string_or_void_item (size_bound)
				create e_u.make_undirected (n3, n4, l)
				create e_u_l.make_undirected (n3, n3, random.alpha_string_or_void_item (size_bound))
				create e_d2.make_directed (n1, n2, random.alpha_string_or_void_item (size_bound))
				create e_u2.make_undirected (n4, n3, l)

				if i \\ 4 = 0 then
					s := e_u.opposite_node (n3)
					b := e_u.is_loop
					b := e_u.is_equal (e_u)
					e_u.set_label (random.alpha_string_or_void_item (size_bound))
					s := e_u.out
					e_u.flip
				elseif i \\ 4 = 1 then
					s := e_u_l.opposite_node (n3)
					b := e_u_l.is_loop
					b := e_u.is_equal (e_u_l)
					e_u_l.set_label (random.alpha_string_or_void_item (size_bound))
					s := e_u_l.out
					e_u_l.flip
				elseif i \\ 4 = 2 then
					s := e_u.opposite_node (n4)
					b := e_d.is_loop
					b := e_d.is_equal (e_d2)
					e_d.set_label (random.alpha_string_or_void_item (size_bound))
					s := e_d.out
					e_u.flip
				else
					s := e_u_l.opposite_node (n3)
					b := e_d_l.is_loop
					b := e_d_l.is_equal (e_u2)
					e_d_l.set_label (random.alpha_string_or_void_item (size_bound))
					s := e_d_l.out
					e_u_l.flip
				end
				i := i + 1
			end

		end
end
