indexing
	description: "Objects that execute features of class LINKED_QUEUE"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	LINKED_QUEUE_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (5, 4)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (10, 6)
			test2 (10, 2)
			test3 (10, 2)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (30, 20)
			test2 (20, 10)
			test3 (20, 10)
		end

feature {NONE} -- Parameters
	item_bound: INTEGER is 100

feature {NONE} -- Tests
	test1 (size_bound, count: INTEGER) is
			-- Test 1 (put and remove) avg `count' * `size_bound' / 2 times
		local
			k, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				is_reference := i \\ 2 = 0
				if is_reference then
					create queue.make
				else
					create {LINKED_QUEUE [INTEGER]} queue.make
				end
				k := random.bounded_item (1, size_bound)
				random.forth
				multiple_put (k)
				remove_all
				i := i + 1
			end
		end

	test2 (size_bound, count: INTEGER) is
			-- Test 3 (change `comparison_criterion' and perform test1) avg `count' * `size_bound' / 2 times
		local
			k, i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				is_reference := i \\ 2 = 0
				if is_reference then
					create queue.make
				else
					create {LINKED_QUEUE [INTEGER]} queue.make
				end
				queue.compare_objects
				k := random.bounded_item (1, size_bound)
				random.forth
				multiple_put (k)
				remove_all
				i := i + 1
			end
		end

	test3 (size_bound, count: INTEGER) is
			-- Test 5 (fill with zeros) avg `count' * `size_bound' / 2 times
		local
			k, i, j: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				is_reference := i \\ 2 = 0
				if is_reference then
					create queue.make
				else
					create {LINKED_QUEUE [INTEGER]} queue.make
				end
				k := random.bounded_item (1, size_bound)
				random.forth
				from
					j := 1
				until
					j > k
				loop
					if is_reference then
						queue.put (Void)
					else
						queue.put (0)
					end
					execute_functions (size_bound)
					j := j + 1
				end
				remove_all
				i := i + 1
			end
		end

feature {NONE} -- Implementation
	queue: LINKED_QUEUE [INTEGER_32_REF]

	is_reference: BOOLEAN

	execute_functions (size_bound: INTEGER) is
			-- Execute functions on `queue'
		require
			size_bound_positive: size_bound > 0
		local
			l: LINEAR [INTEGER_32_REF]
			n: INTEGER_32_REF
			i: INTEGER
			s: like queue
		do
			l := queue.linear_representation
			if queue.readable then
				n := queue.item
			end
			i := random.bounded_item (0, size_bound)
			s := queue.duplicate (i)
		end

	multiple_put (n: INTEGER) is
			-- Put `n' random items into `queue'
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > n
			loop
				if is_reference then
					if random.decide (0.1) then
						queue.put (Void)
					else
						queue.put (random.bounded_item (- item_bound, item_bound).to_reference)
					end
					random.forth
				else
					queue.put (random.bounded_item (- item_bound, item_bound))
				end
				random.forth
				execute_functions (n)
				i := i + 1
			end
		end

	remove_all is
			-- Remove all elements from `queue' one by one
		do
			from
			until
				queue.is_empty
			loop
				queue.remove
				execute_functions (queue.count + 1)
			end
		end
end
