indexing
	description: "Objects that execute features of the class ST_COPY_ON_WRITE_STRING"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ST_COPY_ON_WRITE_STRING_TESTER

inherit
	CLASS_TESTER

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			test1 (45)
			test2 (5)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			test1 (450)
			test2 (50)
		end

feature {NONE} -- Parameters
	size_bound: INTEGER is 1024

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1 (random string)
	local
		i: INTEGER
	do
		from
			i := 1
		until
			i > count
		loop
			create string.make (random.alpha_string_le_item (size_bound))
			if not string.item.is_empty then
				randomize_char
				string.put (char, random.bounded_item (1, string.item.count))
				random.forth
			end
			randomize_char
			string.append_character (char)
			string.append_string (random.alpha_string_le_item (size_bound))
			randomize_char
			string.insert_character (char, random.bounded_item (1, string.item.count + 1))
			random.forth
			execute_functions
			randomize_char
			string.fill_with (char)
			i := i + 1
		end
	end

	test2 (count: INTEGER) is
			-- Test 2 (empty string)
	local
		i: INTEGER
	do
		from
			i := 1
		until
			i > count
		loop
			create string.make ("")
			randomize_char
			string.append_character (char)
			create string.make ("")
			string.append_string (random.alpha_string_le_item (size_bound))
			create string.make ("")
			randomize_char
			string.insert_character (char, random.bounded_item (1, string.item.count + 1))
			random.forth
			create string.make ("")
			execute_functions
			create string.make ("")
			randomize_char
			string.fill_with (char)
			i := i + 1
		end
	end

feature {NONE} -- Implementation
	string: ST_COPY_ON_WRITE_STRING

	char: CHARACTER

	execute_functions is
			-- Execute functions on `string'
		local
			res: STRING
		do
			res := string.safe_item
		end

	randomize_char is
			-- Randomize `char'
		do
			char := random.bounded_item ({CHARACTER}.min_value, {CHARACTER}.max_value).to_character_8
			random.forth
		end
end
