indexing
	description: "Objects that execute features from TIME"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	TIME_TESTER

inherit
	CLASS_TESTER

	TIME_CONSTANTS

feature -- Basic operations
	execute_small_suite is
			-- Execute small test suite
		do
			test1 (10)
		end

	execute_medium_suite is
			-- Execute medium test suite
		do
			-- Run this 5 times with different system time
			test1 (2)
			test2 (8)
		end

	execute_large_suite is
			-- Execute large test suite
		do
			-- Run this 5 times with different system time
			test2 (20)
			test1 (80)
		end

feature {NONE} -- Tests
	test1 (count: INTEGER) is
			-- Test 1
		local
			i, h, m, s: INTEGER
			fs: REAL
			format: STRING
		do
			from
				i := 1
			until
				i > count
			loop
				h := random.bounded_item (0, Hours_in_day - 1)
				random.forth
				m := random.bounded_item (0, Minutes_in_hour - 1)
				random.forth
				s := random.bounded_item (0, Seconds_in_minute - 1)
				random.forth
				fs := random.bounded_item (0, Seconds_in_minute*1000 - 1) / 1000
				random.forth
				create time.make (h, m, s)
				create other.make_fine (h, m, fs)
				execute_functions
				time.make_now
				other.make_now_utc
				s := random.bounded_item (0, Seconds_in_day - 1)
				random.forth
				fs := random.bounded_item (0, Seconds_in_day*1000 - 1) / 1000
				random.forth
				time.make_by_fine_seconds (fs)
				other.make_by_seconds (s)
	--			time.make_from_string_default (other.formatted_out (time.default_format_string))
				format := random_format
				other.make_from_string (random_formatted_time (format), format)
				time.make_by_compact_time (other.compact_time)

				s := random.bounded_item (-1000, 1000)
				random.forth
				fs := random.bounded_real_item (-1000, 1000)
				random.forth
				time.second_add (s)
				time.fine_second_add (fs)
				time.minute_add (s)
				time.hour_add (s)
				time.second_forth
				time.second_back
				time.minute_forth
				time.minute_back
				time.hour_forth
				time.hour_back
				i := i + 1
			end
		end

	test2 (count: INTEGER) is
			-- Test 2 (zero time)
		local
			i: INTEGER
			format: STRING
		do
			from
				i := 1
			until
				i > count
			loop
				create time.make (0, 0, 0)
				create other.make_fine (0, 0, 0.0)
				execute_functions
				time.make_by_fine_seconds (0.0)
				other.make_by_seconds (0)
	--			time.make_from_string_default (other.formatted_out (time.default_format_string))
				format := random_format
				other.make_from_string (time.origin.formatted_out (format), format)
				time.make_by_compact_time (0)

				time.second_add (0)
				time.fine_second_add (0.0)
				time.minute_add (0)
				time.hour_add (0)
				time.second_forth
				time.second_back
				time.minute_forth
				time.minute_back
				time.hour_forth
				time.hour_back
				i := i + 1
			end
		end

feature {NONE} -- Implementation
	execute_functions is
			-- Execute functions on `time'
		local
			res: TIME
			b: BOOLEAN
			n: INTEGER
			d: DOUBLE
			s: STRING
		do
			res := time.origin
			b := time < other
			n := time.seconds
			d := time.fine_seconds
			duration := time.duration
			duration := time.relative_duration (other)
			res := time + duration
			s := time.out
			s := time.formatted_out (random_format)
		end

	random_format: STRING is
			-- Random time format
		local
			i: INTEGER
		do
			i := random.bounded_item (1, 8)
			random.forth
			inspect i
			when 1 then Result := "hh:mi:ss"
			when 2 then Result := "hh.mi.ss"
			when 3 then Result := "hh-mi-ss"
			when 4 then Result := "hh,mi,ss"
			when 5 then Result := "hh/mi/ss"
			when 6 then Result := "[0]hh:mi:ss"
			when 7 then Result := "[0]hh:[0]mi:ss"
			when 8 then Result := "[0]hh:[0]mi:[0]ss"
			end
		end

	random_formatted_time (format: STRING): STRING is
			-- Random time in `format'
		local
			h, m, s: INTEGER
			str: STRING
		do
			h := random.bounded_item (0, Hours_in_day - 1)
			random.forth
			m := random.bounded_item (0, Minutes_in_hour - 1)
			random.forth
			s := random.bounded_item (0, Seconds_in_minute - 1)
			random.forth
			Result := format.string
			str := h.out
			if str.count = 1 then str.prepend ("0") end
			Result.replace_substring_all ("[0]hh", str)
			Result.replace_substring_all ("hh", h.out)
			str := m.out
			if str.count = 1 then str.prepend ("0") end
			Result.replace_substring_all ("[0]mi", str)
			Result.replace_substring_all ("mi", m.out)
			str := s.out
			if str.count = 1 then str.prepend ("0") end
			Result.replace_substring_all ("[0]ss", str)
			Result.replace_substring_all ("ss", s.out)
		end

	time, other: TIME
	duration: TIME_DURATION
end
